# main.py -- put your code here!
import pyb
import network
import usocket as socket

SSID = "ST67_fat_2.4G"					# 填入要連線的WiFi熱點名稱
PASS = "0988719859"						# Wi-Fi熱點密碼
HOST = "ideaschain.com.tw"				# 伺服器網址，不可動
API_URL = "iiot.ideaschain.com.tw"		# 連線對象URL，不可動
DEVICE_KEY = "N0aQ40M9R8PbGN6ucZLz"		# 資料平台裝置的存取權限碼
def wifi(): 							# 連線到Wi-Fi熱點的定義函數
	try:
		print("connecting to wifi")
		wlan = network.WLAN()			# 設定Wi-Fi的連線類型為WLAN
		wlan.connect(SSID, PASS)		# 連線至Wi-Fi

	except:
		print("Wifi module initial error, reconnecting......")
		pyb.delay(1000)					# 延遲1秒(=1000毫秒)
		wifi()							# 若連線失敗，則重新執行此函數

wifi()									#  執行此函數
print("Wi-Fi connect")

param_data = "{\n \"key1\": \"value1\"\n}"	#  上傳訊息內容格式，其中key1為資料名稱(如溫度、濕度...等)，value1為資料內容(如28、66.5...等)
param_lenth = str(len(param_data))		# 計算訊息的字串總長度

addr = socket.getaddrinfo(HOST, 80)[0][-1]	# 取得連線到伺服器的相關訊息
print(addr)								# 顯示取得的address訊息內容

request_str = """\						
POST /api/v1/"""+DEVICE_KEY+"""/telemetry HTTP/1.1\r
Content-Type: application/json\r
Content-Length: """+param_lenth+"""\r
Host: """+API_URL+"""\r
\r\n"""+param_data						# 定義發送至伺服器的訊息內容


print(request_str);						# 顯示此訊息內容進行debug

def go(): 
	try:
		s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)	# 與伺服器連線前，將設定相關參數
		print("connecting to server")
		s.connect(addr)					# 與伺服器進行連線
		pyb.delay(1000)
		print("server is connected")
		s.send(bytes(request_str, 'utf8'))	# 將訊息內容上傳至伺服器對應的裝置中
		print("send done")
		pyb.delay(1000)
		s.close()						# 關閉與伺服器的連線，避免佔用端口。
	except:
		print("except")
		pyb.delay(1000)

while True:					# 將下述內容迴圈執行
	go()					# 執行此函數
	pyb.delay(2000)

